import os,sys,inspect
import time
import datetime


def recordement(mr, target_param):
    def decorated(f):
        def wrapper(*args, **kwargs):
            params = f.__code__.co_varnames[:f.__code__.co_argcount]
            tp_idx = params.index(target_param)
            tp_val = args[tp_idx]
            start = time.time()
            result = f(*args, **kwargs)
            finish = time.time()
            f_instance = args[0]
            tp_count = getattr(f_instance, 'count')
            mr.record(f.__name__, start, finish, tp_val, tp_count)
            return result

        wrapper.__name__ = f.__name__
        return wrapper

    return decorated


class MetricsRecorder:
    def __init__(self):
        self.events = []

    # def __call__(self, *args, **kwargs):
    #    start = time.time()
    #    result = self.f(*args, **kwargs)
    #    finish = time.time()
    #    self.record(self.f.__name__, start, finish)
    #    return result

    def record(self, target, started, finished, entity, count):
        self.events.append((target, started, finished, entity, count))

    def rts(self, timestamp):
        # rts - readable timestamp
        ts_format = '%Y-%m-%d %H:%M:%S.%f'
        return datetime.datetime.utcfromtimestamp(timestamp).strftime(ts_format)

    def spill(self):
        event_history = []
        chronology = sorted(self.events, key=lambda x: x[1])
        for event in chronology:
            target, started, finished, entity, count = event
            elapsed = finished - started
            workspaces, count_items = zip(*count.items())
            workspace = workspaces[0]
            count = count_items[0]
            #print("{0:24.24s} Z  {1:20.20s} {2:24.24s} Z  {3:7.4f}".format(
            #    self.rts(started), target, self.rts(finished), elapsed))
            nugget = "{0:32.32s} {1:24.24s} {2:24.24s}  {3:7d} items in {4:9.4f} seconds".format(target, workspace, entity, count, elapsed)
            event_history.append(nugget)
        return event_history

metrixeur = MetricsRecorder()
